#include "SehDebuggerDetection.h"

SehDbgDetection::SehDbgDetection() {
};

// ----------------------------------------------------------------------------------------------------------------------------

bool SehDbgDetection::CloseHandleExcepDetection(HANDLE invalid) {

	__try {

		CloseHandle(invalid);
	}

	__except (EXCEPTION_EXECUTE_HANDLER) {

		return true;

	}

	return false;

}

// ---------------------------------------------------------------------------------------------------------------------------

bool SehDbgDetection::SingleStepExcepDetection() {

	__try {

		__asm {
			PUSHFD // push the flag registers to the stack so we can manipulate them
			OR BYTE PTR[ESP + 1], 1 // Set the trap flag
			POPFD // Restore the flag registers after manipulation
			NOP // try to execute next command to generate the exception
		}

	}

	__except (EXCEPTION_EXECUTE_HANDLER) {

		return false;

	}

	return true;

}
